#!/bin/bash

FILES=`echo src/at/dms/compiler/*.java src/at/dms/kjc/*.java src/at/dms/backend/*.java src/at/dms/optimize/*.java`
JAR=kopi-compiler.jar
NAME="at.dms.kjc"

#       -verbose \
rm -rf classes/at
( java -Xms32M -Xmx48M -verify -jar jars/kopi-compiler.jar -d classes \
       -classpath src:../libs/gnugetopt.jar:../libs/antlr.jar:../util/jars/kopi-util.jar:../classfile/jars/kopi-classfile.jar -debug \
       $FILES \
  && echo "Compilation of $NAME finished." \
  && jar cmf0 jars/manifest jars/$JAR -C classes at \
  && echo "Jar file $JAR created.") 2>&1
