#!/bin/sh

echo "First rebuilding all from source..."
./make.sh

echo "Unpacking individual jar files in tmp directory"
mkdir -p tmp
( cd tmp;
  ( echo ../*/jars/kopi-*.jar | xargs -n 1 jar -xf );
  jar -xf ../libs/antlr.jar ;
  jar -xf ../libs/gnugetopt.jar
)

echo "Now making one big ksusu.jar file that contains all libraries and the compiler"
jar cmf0 libs/ksusu-jar-manifest ksusu.jar -C tmp .

echo "Finished"
