#!/bin/sh

source ../settings

FILES=`echo src/at/dms/msggen/*.java`
JARFILE=kopi-msggen.jar
NAME="at.dms.msggen"

rm -rf classes/at
( $COMPILER -d classes \
       -classpath src:../libs/gnugetopt.jar:../libs/antlr.jar:../util/jars/kopi-util.jar:$JIKESPATH \
       $FILES \
  && echo "Compilation of $NAME finished." \
  && $JAR cmf0 jars/manifest jars/$JARFILE -C classes at \
  && echo "Jar file $JARFILE created.") 2>&1
