/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package at.dms.msggen;

import at.dms.util.MessageDescription;

/**
 * The message list for Msggen
 */
public class MsggenMessages {
  public static final MessageDescription UNKNOWN_FILE = 
    new MessageDescription("File \"{0}\" not found", null, MessageDescription.LVL_ERROR);
  public static final MessageDescription TOKEN_STREAM_ERROR = 
    new MessageDescription("Token stream error on file {0}: {1}", null, MessageDescription.LVL_ERROR);
  public static final MessageDescription PARSING_ERROR = 
    new MessageDescription("Parsing error on file {0}: {1}", null, MessageDescription.LVL_ERROR);
  public static final MessageDescription IO_EXCEPTION = 
    new MessageDescription("I/O Exception on file {0}: {1}", null, MessageDescription.LVL_ERROR);
  public static final MessageDescription DUPLICATE_DEFINITION = 
    new MessageDescription("Message \"{0}\" redefined in \"{1}\": previous definition in \"{2}\"", null, MessageDescription.LVL_ERROR);
}
