#!/bin/sh

source ../settings

FILES=`echo src/at/dms/util/*.java`
JARFILE=kopi-util.jar
NAME="at.dms.util"

rm -rf classes/at
( $COMPILER -d classes \
       -classpath src:../libs/gnugetopt.jar:$JIKESPATH $FILES \
  && echo "Compilation of $NAME finished." \
  && $JAR cmf0 jars/manifest jars/$JARFILE -C classes at \
  && echo "Jar file $JARFILE created.") 2>&1
